/// <reference types="express" />
import { Request, Response } from 'express';
import { Command, CommandBus } from 'alpha-command-bus';
export interface MappingContext {
    request: Request;
    command: Command;
    response: Response;
}
export declare type ResultHandler = (result: any, context: MappingContext, parentResultHandler?: ResultHandler) => any;
export declare type ErrorHandler = (error: any, context: MappingContext, parentErrorHandler?: ErrorHandler) => any;
export interface MapperConfig {
    resultHandler: ResultHandler;
    errorHandler: ErrorHandler;
}
export declare const DEFAULT_RESULT_HANDLER: (result: any, context: MappingContext) => void;
export declare const DEFAULT_ERROR_HANDLER: (result: any, context: MappingContext) => void;
export declare class Mapper {
    private commandBus;
    private config;
    constructor(commandBus: CommandBus, config?: Partial<MapperConfig>);
    map(mapper: (req: Request) => Command, config?: Partial<MapperConfig>): (request: Request, response: Response) => Promise<void>;
}
